#window.py
#############################################################################
#
#  Linux Desktop Testing Project http://ldtp.freedesktop.org
# 
#  Author:
#     Alex Yu <tae.ccf@gmail.com>
# 
#  Copyright 2004 - 2006 Palmsource, Inc.
# 
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Library General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
# 
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Library General Public License for more details.
# 
#  You should have received a copy of the GNU Library General Public
#  License along with this library; if not, write to the
#  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
#  Boston, MA 02111-1307, USA.
#
#############################################################################
import ldtp
import time

class widget:
    pass
    #def waitexists(self):
        #print self.name
        #print self.windowname
        
    #def exists(self):
        #if self.windowname != '':
            #win = self.windowname
        #else:
            #win = Window.wname
            
        #print win
        #print self.name
        #print '============================'
class option:
    pass

class Window:
    def __init__(self, wname=''):
        Window.wname = wname

        if wname != '':
            self.windowname = Window.wname
        else:
            self.windowname = self.name

    def setactive(self):
        pass
    
    def waitexists(self, timeout):
        seconds = 0
        while ldtp.guiexist(self.windowname) == 0 and seconds < timeout:
            time.sleep(1)
            seconds += 1
            
        if seconds == timeout:
            print 'failed to wait window %s exists' % self.windowname
            return 0
        else:
            print 'window %s appeared' % self.windowname
            return 1
    
    def exists(self):
        return ldtp.guiexist(self.windowname)

    def close(self):
        pass

    class PushButton(widget):
        def __init__(self, widgetname, windowname=''):
            if windowname == '':
                self.windowname = Window.wname 
            else:
                self.windowname = windowname
                
            self.widgetname = widgetname
            
        def click(self):
            Window(self.windowname).waitexists(10)
            ldtp.click(self.windowname, self.widgetname)
            
        def isenabled(self):
            Window(self.windowname).waitexists(10)
            return ldtp.stateenabled(self.windowname, self.widgetname)
        
    
    class MenuItem(widget):
        def __init__(self, widgetname, windowname=''):
            if windowname == '':
                self.windowname = Window.wname 
            else:
                self.windowname = windowname
                
            self.widgetname = widgetname
            
        def pick(self):
            Window(self.windowname).waitexists(10)
            ldtp.selectmenuitem(self.windowname, self.widgetname)
            
        def exists(self):
            Window(self.windowname).waitexists(10)
            return ldtp.doesmenuitemexist(self.windowname,self.widgetname)
        
        def getsubmenus(self):
            Window(self.windowname).waitexists(10)
            return ldtp.listsubmenus(self.windowname, self.widgetname)
            
    class Text(widget):
        def __init__(self, widgetname, windowname=''):
            if windowname == '':
                self.windowname = Window.wname 
            else:
                self.windowname = windowname
                
            self.widgetname = widgetname
        
        def setfocus(self):
            Window(self.windowname).waitexists(10)
            ldtp.activatetext(self.windowname, self.widgetname)
            
        def append(self, text):
            Window(self.windowname).waitexists(10)
            ldtp.appendtext(self.windowname,self.widgetname, text)

        def gettext(self, startoffset=0, endoffset=0):
            Window(self.windowname).waitexists(10)
            return ldtp.gettextvalue(self.windowname, self.widgetname, startoffset, endoffset)
        
        def cleartext(self):
            Window(self.windowname).waitexists(10)
            str = ''
            str = Window(self.windowname).Text(self.widgetname).gettext()
            ldtp.deletetext(self.windowname, self.widgetname, 0, len(str))
        
        def settext(self, text, startoffset=0):
            Window(self.windowname).waitexists(10)
            if startoffset == 0:
                ldtp.settextvalue(self.windowname, self.widgetname, text)
            else:
                ldtp.inserttext(self.windowname, self.widgetname, startoffset, text)
        
                
    class CheckBox(widget):
        def __init__(self, widgetname, windowname=''):
            if windowname == '':
                self.windowname = Window.wname 
            else:
                self.windowname = windowname
                
            self.widgetname = widgetname
            
        def check(self):
            Window(self.windowname).CheckBox(self.widget).waitexists(10)
            ldtp.check(self.windowname, self.widgetname)
            
        def uncheck(self):
            Window(self.windowname).CheckBox(self.widget).waitexists(10)
            ldtp.uncheck(self.windowname, self.widgetname)   
        
        def getstate(self):
            Window(self.windowname).waitexists(10)
            return ldtp.verifycheck(self.windowname, self.widgetname)
            
    class ComboBox(widget):
        def __init__(self, widgetname, windowname=''):
            if windowname == '':
                self.windowname = Window.wname 
            else:
                self.windowname = windowname
                
            self.widgetname = widgetname
            
        def click(self):
            Window(self.windowname).waitexists(10)
            ldtp.click(self.windowname, self.widgetname)
            
        def hidelist(self):
            ''' hides combo box drop down list.'''
            Window(self.windowname).waitexists(10)
            ldtp.hidelist(self.windowname, self.widgetname)
            
        def select(self, item):
            # select item in combobox, if item is integer then call ldtp.selectindex(), if it is string call ldtp.comboselect()
            Window(self.windowname).waitexists(10)
            if type(item) == str:
                ldtp.comboselect(self.windowname, self.widgetname, item)
            if type(item) == int:
                ldtp.selectindex(self.windowname, self.widgetname)
        
        def settext(self, text):
            Window(self.windowname).waitexists()
            ldtp.settextvalue(self.windowname, self.widgetname, text)
        
        def showlist(self):
            Window(self.windowname).waitexists(10)
            ldtp.showlist(self.windowname, self.widgetname)
            
    class List(widget):
        def __init__(self, widgetname, windowname=''):
            if windowname == '':
                self.windowname = Window.wname 
            else:
                self.windowname = windowname
                
            self.widgetname = widgetname    
        
        def select(self, item):
            Window(self.windowname).waitexists(10)
            if type(item) == str:
                ldtp.selecttextitem(self.windowname, self.widgetname)
            if type(item) == int:
                ldtp.selectindex(self.windowname, self.widgetname)
                
    class RadioButton(widget):
        def __init__(self, widgetname, windowname=''):
            if windowname == '':
                self.windowname = Window.wname 
            else:
                self.windowname = windowname
                
            self.widgetname = widgetname    
        
        def click(self):
            Window(self.windowname).waitexists(10)
            ldtp.click(self.windowname, self.widgetname)
                 
        def check(self):
            Window(self.windowname).waitexists(10)
            ldtp.check(self.windowname, self.widgetname)
            
        def getstate(self):
            Window(self.windowname).waitexists(10)
            return ldtp.stateenabled(self.windowname, self.widgetname)
            
        def ischecked(self):
            Window(self.windowname).waitexists(10)
            return ldtp.verifycheck(self.windowname, self.widgetname)
        
    class Table(widget):
        def __init__(self, widgetname, windowname=''):
            if windowname == '':
                self.windowname = Window.wname 
            else:
                self.windowname = windowname
                
            self.widgetname = widgetname           
            
        def checkrow(self, row, col=0):
            Window(self.windowname).waitexists(10)
            ldtp.checkrow(self.windowname, self.widgetname, row, col)
            
        def uncheckrow(self, row, col=0):
            Window(self.windowname).waitexists(10)
            ldtp.uncheckrow(self.windowname, self.widgetname, row, col)
            
        def getrowcount(self):
            Window(self.windowname).waitexists(10)
            return ldtp.getrowcount(self.windowname, self.widgetname)
        
        def getrowindex(self, cellvalue):
            Window(self.windowname).waitexists(10)
            return ldtp.gettablerowindex(self.windowname, self.widgetname, cellvalue)
        
        def selectrow(self, item):
            Window(self.windowname).waitexists(10)
            if type(item) == str:
                ldtp.selectrow(self.windowname, self.widgetname, item)
            if type(item) == int:
                ldtp.selectrowindex(self.windowname, self.widgetname, item)
                
        def setcellvalue(self, row, col, item):
            Window(self.windowname).waitexists(10)
            ldtp.setcellvalue(self.windowname, self.widgetname, row,  col, item)
            
        
            
